#include <stdio.h>

#include "tunes.h"

struct binding {
  const char *name;
  primfunc_t nm;
} bindings[] = {
  { "call/cc", PF_CALL_CC },
  { "print", PF_PRINT },
  { NULL, 0 }
};

objptr_t
build_primfunc (primfunc_t nm)
{
  objptr_t obj;

  obj = allocate ();
  core[obj].type = O_PRIMFUNC;
  core[obj].d.primfunc_v.nm = nm;
  return obj;
}

objptr_t
build_def (hashv_t name, objptr_t val)
{
  objptr_t obj;

  obj = allocate ();
  core[obj].type = O_DEF;
  core[obj].d.def_v.name = name;
  core[obj].d.def_v.val = val;
  return obj;
}

objptr_t
build_envnull (void)
{
  objptr_t obj;

  obj = allocate ();
  core[obj].type = O_ENVNULL;
  return obj;
}

objptr_t
build_env (objptr_t def, objptr_t seq)
{
  objptr_t obj;

  obj = allocate ();
  core[obj].type = O_ENV;
  core[obj].d.env_v.def = def;
  core[obj].d.env_v.seq = seq;
  return obj;
}

void
create_globenv (void)
{
  struct binding *ptr;

  globenv = build_envnull ();
  for ( ptr=bindings ; ptr->name ; ptr++ )
    {
      globenv = build_env (build_def (hash_string (ptr->name),
				      build_primfunc (ptr->nm)),
			   globenv);
    }
}
