%{
#include "tunes.h"
#include "y.tab.h"
%}

IDENTFIRSTCHAR	[a-zA-Z_*~=]
IDENTCHAR	[a-zA-Z0-9_*~=/-]
IDENTLASTCHAR	[a-zA-Z0-9_*~=]

%%

[ \t\r\n]+	/* Eat up whitespace */

"#"[^\n]*\n	/* Eat up comments */

{IDENTFIRSTCHAR}{IDENTCHAR}*{IDENTLASTCHAR} yylval.ident = hash_string (yytext); return TOK_IDENT;
{IDENTFIRSTCHAR} yylval.ident = hash_string (yytext); return TOK_IDENT;

"@.".		yylval.char_v = yytext[2];  return TOK_CHARVAL;
"@\\n"		yylval.char_v = '\n';  return TOK_CHARVAL;
"@\\r"		yylval.char_v = '\r';  return TOK_CHARVAL;
"@\\t"		yylval.char_v = '\t';  return TOK_CHARVAL;

"@f"		yylval.bool_v = 0;  return TOK_BOOLVAL;
"@t"		yylval.bool_v = 1;  return TOK_BOOLVAL;

"-"?[0-9]+	yylval.int_v = atoi (yytext);  return TOK_INTVAL;

"("		return TOK_LPAREN;

")"		return TOK_RPAREN;

";"		return TOK_SEMICOLON;

">"		return TOK_ARROW;

.		error ("invalid character");
